setup-disk.in 23.6 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"

6
MBR=${MBR:-"/usr/share/syslinux/mbr.bin"}
7 8
ROOTFS=${ROOTFS:-ext4}
BOOTFS=${BOOTFS:-ext4}
9
VARFS=${VARFS:-ext4}
Natanael Copa's avatar
Natanael Copa committed
10

11 12 13
# default location for mounted root
SYSROOT=${SYSROOT:-/mnt}

Natanael Copa's avatar
Natanael Copa committed
14 15 16 17 18 19 20 21 22 23
in_list() {
	local i="$1"
	shift
	while [ $# -gt 0 ]; do
		[ "$i" = "$1" ] && return 0
		shift
	done
	return 1
}

24 25 26 27 28 29 30 31 32 33 34
all_in_list() {
	local needle="$1"
	local i
	[ -z "$needle" ] && return 1
	shift
	for i in $needle; do
		in_list "$i" $@ || return 1
	done
	return 0
}

35 36 37 38 39 40 41 42
# wrapper to only show given device
_blkid() {
	blkid | grep "^$1:"
}

# if given device have an UUID display it, otherwise return the device
uuid_or_device() {
	local i=
43 44 45
	case "$1" in
		/dev/md*) echo "$1" && return 0;;
	esac
46 47 48 49 50 51 52 53 54 55 56 57 58
	for i in $(_blkid "$1"); do
		case "$i" in
			UUID=*) eval $i;;
		esac
	done
	if [ -n "$UUID" ]; then
		echo "UUID=$UUID"
	else
		echo "$1"
	fi
}

# generate an fstab from a given mountpoint. Convert to UUID if possible
59
enumerate_fstab() {
60
	local mnt="$1"
61
	local fs_spec= fs_file= fs_vfstype= fs_mntops= fs_freq= fs_passno=
62
	[ -z "$mnt" ] && return
63 64
	local escaped_mnt=$(echo $mnt | sed -e 's:/*$::' -e 's:/:\\/:g')
	awk "\$2 ~ /^$escaped_mnt(\/|\$)/ {print \$0}" /proc/mounts | \
65
		sed "s:$mnt:/:g; s: :\t:g" | sed -E 's:/+:/:g' | \
66 67 68
		while read fs_spec fs_file fs_vfstype fs_mntops fs_freq fs_passno; do
			echo -e "$(uuid_or_device $fs_spec)\t${fs_file}\t${fs_vfstype}\t${fs_mntops} ${fs_freq} ${fs_passno}"
		done
69 70
}

71 72 73 74 75
is_vmware() {
	grep -q VMware /proc/scsi/scsi 2>/dev/null \
		|| grep -q VMware /proc/ide/hd*/model 2>/dev/null
}

76 77 78 79 80
# return true (0) if given device is lvm
is_lvm() {
	lvs "$1" >/dev/null 2>&1
}

81 82
# Find the disk device from given partition
disk_from_part() {
83 84
	# we need convert cciss/c0d0* cciss!c0d0*...
	local i= part=$(echo ${1#/dev/} | sed 's:/:!:g')
85 86
	for i in /sys/block/*/$part; do
		i=${i%/*}
87
		# ...and back from cciss!c0d0 to cciss/c0d0
88 89 90 91
		if [ -b "/dev/${i##*/}" ]; then
			echo "/dev/${i##*/}" | sed 's:!:/:g'
			return 0
		fi
92 93 94 95
	done
	return 1
}

96 97 98 99 100 101 102 103 104 105 106 107 108 109
unpack_apkovl() {
	local ovl="$1"
	local dest="$2"
	local suffix=${ovl##*.}
	local i
	ovlfiles=/tmp/ovlfiles
	if [ "$suffix" = "gz" ]; then
		if ! tar -C "$dest" --numeric-owner -zxvf "$ovl" > $ovlfiles; then
			echo -n "Continue anyway? [Y/n]: "
			read i
			case "$i" in
				n*|N*) return 1;;
			esac
		fi
110
		return 0
111 112
	fi

113
	apk add --quiet openssl
114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130

	if ! openssl list-cipher-commands | grep "^$suffix$" > /dev/null; then
		errstr="Cipher $suffix is not supported"
		return 1
	fi
	local count=0
	# beep
	echo -e "\007"
	while [ $count -lt 3 ]; do
		openssl enc -d -$suffix -in "$ovl" | tar --numeric-owner \
			-C "$dest" -zxv >$ovlfiles 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	ovlfiles=
	return 1
}

131 132 133 134 135 136 137 138
# find filesystem of given mounted dir
find_mount_fs() {
	local mount_point="$1"
	awk "\$2 == \"$mount_point\" {print \$3}" /proc/mounts | tail -n 1
}

# find device for given mounted dir
find_mount_dev() {
139
	local mnt="$1"
140 141 142 143
	awk "\$2 == \"$mnt\" { print \$1 }" /proc/mounts | tail -n 1
}

supported_boot_fs() {
144
	local supported="ext2 ext3 ext4 btrfs"
145 146 147 148 149 150 151 152
	local fs=
	for fs in $supported; do
		[ "$fs" = "$1" ] && return 0
	done
	echo "$1 is not supported. Only supported are: $supported" >&2
	return 1
}

153 154 155 156 157 158 159 160 161 162
find_volume_group() {
	local lv=${1##*/}
	lvs --noheadings "$1" | awk "\$1 == \"$lv\" {print \$2}"
}

find_pvs_in_vg() {
	local vg="$1"
	pvs --noheadings | awk "\$2 == \"$vg\" {print \$1}"
}

163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187
# echo current grsecurity option and set new
set_grsec() {
	local key="$1" value="$2"
	if ! [ -e /proc/sys/kernel/grsecurity/$key ]; then
		return 0
	fi
	cat /proc/sys/kernel/grsecurity/$key
	echo $value > /proc/sys/kernel/grsecurity/$key
}

init_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		mkdir -p "$mnt"/$i
		mount --bind /$i "$mnt"/$i
	done
}

cleanup_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		umount "$mnt"/$i
	done
}

188
install_mounted_root() {
Natanael Copa's avatar
Natanael Copa committed
189
	local mnt="$1" mnt_boot= boot_fs= root_fs=
190
	local initfs_features="ata base ide scsi usb virtio"
191
	local pvs= dev= rootdev= bootdev= extlinux_raidopt= root= modules=
192
	local kernel_opts="quiet"
193

194
	rootdev=$(find_mount_dev "$mnt")
195 196 197 198
	if [ -z "$rootdev" ]; then
		echo "$mnt does not seem to be a mount point" >&2
		return 1
	fi
199
	root_fs=$(find_mount_fs "$mnt")
200 201 202 203
	initfs_features="$initfs_features $root_fs"

	if is_lvm "$rootdev"; then
		initfs_features="$initfs_features lvm"
204 205
		local vg=$(find_volume_group "$rootdev")
		pvs=$(find_pvs_in_vg $vg)
206 207
	fi

208

209 210 211
	bootdev=$(find_mount_dev "$mnt"/boot)
	if [ -z "$bootdev" ]; then
		bootdev=$rootdev
Natanael Copa's avatar
Natanael Copa committed
212
		mnt_boot="$mnt"
213 214 215 216 217 218
	else
		mnt_boot="$mnt"/boot
	fi
	boot_fs=$(find_mount_fs "$mnt_boot")
	supported_boot_fs "$boot_fs" || return 1

219 220
	# Check if we boot from raid so we can pass proper option to
	# extlinux later.
221
	if [ -e "/sys/block/${bootdev#/dev/}/md" ]; then
222
		extlinux_raidopt="--raid"
223
	fi
224

225 226
	# check if our root is on raid so we can feed mkinitfs and
	# update-exlinux.conf with the proper kernel module params
227 228 229 230
	for dev in $rootdev $pvs; do
		[ -e "/sys/block/${dev#/dev/}/md" ] || continue

		local md=${dev#/dev/}
231
		initfs_features="${initfs_features% raid} raid"
232 233
		local level=$(cat /sys/block/$md/md/level)
		case "$level" in
234 235
			raid1) raidmod="${raidmod%,raid1},raid1";;
			raid[456]) raidmod="${raidmod%,raid456},raid456";;
236 237
		esac
	done
238 239 240 241

	# check if we need hardware raid drivers
	case $rootdev in
		/dev/cciss/*)
242
			initfs_features="${initfs_features% raid} raid"
243 244 245
			;;
	esac

246 247 248 249 250 251
	if [ -n "$VERBOSE" ]; then
		echo "Root device:     $rootdev"
		echo "Root filesystem: $root_fs"
		echo "Boot device:     $bootdev"
		echo "Boot filesystem: $boot_fs"
	fi
252

253
	if [ -z "$APKOVL" ]; then
254 255
		ovlfiles=/tmp/ovlfiles
		lbu package - | tar -C "$mnt" -zxv > "$ovlfiles"
256 257 258 259
		# comment out local repositories
		if [ -f "$mnt"/etc/apk/repositories ]; then
			sed -i -e 's:^/:#/:' "$mnt"/etc/apk/repositories
		fi
260 261
	else
		echo "Restoring backup from $APKOVL to $rootdev..."
262
		unpack_apkovl "$APKOVL" "$mnt" || return 1
263
	fi
264

265
	# generate mkinitfs.conf
266
	mkdir -p "$mnt"/etc/mkinitfs/features.d
267
	echo "features=\"$initfs_features\"" > "$mnt"/etc/mkinitfs/mkinitfs.conf
268
	if [ -n "$raidmod" ]; then
269 270
		echo "/sbin/mdadm" > "$mnt"/etc/mkinitfs/features.d/raid.files
		echo "/etc/mdadm.conf" >> "$mnt"/etc/mkinitfs/features.d/raid.files
271
	fi
272

273 274 275 276 277 278 279 280 281 282
	# generate update-extlinux.conf
	root=$(uuid_or_device $rootdev)
	if is_vmware; then
		kernel_opts="pax_nouderef $kernel_opts"
	fi
	modules="sd-mod,usb-storage,${root_fs}${raidmod}"
	sed -e "s:^root=.*:root=$root:" \
		-e "s:^default_kernel_opts=.*:default_kernel_opts=\"$kernel_opts\":" \
		-e "s:^modules=.*:modules=$modules:" \
		/etc/update-extlinux.conf > "$mnt"/etc/update-extlinux.conf
283 284 285 286
	if [ "$(rc --sys)" = "XEN0" ]; then
		sed -i -e "s:^default=.*:default=xen-grsec:" \
			"$mnt"/etc/update-extlinux.conf
	fi
287

288 289 290 291 292
	# generate the fstab
	if [ -f "$mnt"/etc/fstab ]; then
		mv "$mnt"/etc/fstab "$mnt"/etc/fstab.old
	fi
	enumerate_fstab "$mnt" >> "$mnt"/etc/fstab
293 294 295 296
	if [ -n "$SWAP_DEVICE" ]; then
		echo -e "${SWAP_DEVICE}\tswap\tswap\tdefaults\t0 0" \
			>> "$mnt"/etc/fstab
	fi
297 298 299 300 301
	cat >>"$mnt"/etc/fstab <<EOF
/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
/dev/fd0	/media/floppy	vfat	noauto	0 0
/dev/usbdisk	/media/usb	vfat	noauto	0 0
EOF
302
	# remove the installed db in case its there so we force re-install
303
	rm -f "$mnt"/var/lib/apk/installed "$mnt"/lib/apk/db/installed
304
	echo "Installing system on $rootdev:"
305 306
	extlinux $extlinux_raidopt --install "$mnt"/boot

307 308 309 310
	# apk reads config from target root so we need to copy the config
	mkdir -p "$mnt"/etc/apk/keys/
	cp /etc/apk/keys/* "$mnt"/etc/apk/keys/

311
	local apkflags="--initdb --quiet --progress --update-cache --clean-protected"
312
	local pkgs=$(cat "$mnt"/etc/apk/world "$mnt"/var/lib/apk/world 2>/dev/null)
313
	pkgs="$pkgs acct linux-$KERNEL_FLAVOR alpine-base"
314 315 316
	if [ "$(rc --sys)" = "XEN0" ]; then
		pkgs="$pkgs xen-hypervisor"
	fi
317 318 319 320 321
	local repos=$(sed -e 's/\#.*//' /etc/apk/repositories)
	local repoflags=
	for i in $repos; do
		repoflags="$repoflags --repository $i"
	done
322

323 324
	chroot_caps=$(set_grsec chroot_caps 0)
	init_chroot_mounts "$mnt"
325
	apk add --root "$mnt" $apkflags --overlay-from-stdin \
Natanael Copa's avatar
Natanael Copa committed
326
		$repoflags $pkgs <$ovlfiles
327 328 329 330
	local ret=$?
	cleanup_chroot_mounts "$mnt"
	set_grsec chroot_caps $chroot_caps > /dev/null
	return $ret
331 332 333 334
}

unmount_partitions() {
	local mnt="$1"
335 336

	# unmount the partitions
Natanael Copa's avatar
Natanael Copa committed
337
	umount $(awk '{print $2}' /proc/mounts | egrep "^$mnt(/|\$)" | sort -r)
338
}
339

340 341 342
# figure out decent default swap size in mega bytes
find_swap_size() {
	local memtotal_kb=$(awk '$1 == "MemTotal:" {print $2}' /proc/meminfo)
343 344 345 346
	# use 2 * avaiable ram or no more than 1/3 of smallest disk space
	local size=$(( $memtotal_kb * 2 / 1024 ))
	local disk= disksize=
	for disk in $@; do
347 348
		local sysfsdev=$(echo ${disk#/dev/} | sed 's:/:!:g')
		local sysfspath=/sys/block/$sysfsdev/size
349 350 351 352 353 354 355 356 357 358 359 360 361 362 363
		# disksize = x * 512 / (1024 * 1024) = x / 2048
		# maxsize = $disksize / 4 = x / (2048 * 4) = x / 8192
		maxsize=$(awk '{ printf "%i", $0 / 8192 }' $sysfspath )
		if [ $size -gt $maxsize ]; then
			size=$maxsize
		fi
	done
	if [ $size -gt 4096 ]; then
		# dont ever use more than 4G
		size=4096
	elif [ $size -lt 64 ]; then
		# dont bother create swap smaller than 64MB
		size=0
	fi
	echo $size
364 365 366 367
}

has_mounted_part() {
	local p
368
	local sysfsdev=$(echo ${1#/dev/} | sed 's:/:!:g')
Natanael Copa's avatar
Natanael Copa committed
369
	# parse /proc/mounts for mounted devices
370
	for p in $(awk '$1 ~ /^\/dev\// {gsub("/dev/", "", $1); gsub("/", "!", $1); print $1}' \
371
			/proc/mounts); do
372 373
		[ "$p" = "$sysfsdev" ] && return 0
		[ -e /sys/block/$sysfsdev/$p ] && return 0
374 375 376 377
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
378 379 380 381 382 383 384 385 386 387 388 389 390 391 392
has_holders() {
	local i
	# check if device is used by any md devices
	for i in $1/holders/* $1/*/holders/*; do
		[ -e "$i" ] && return 0
	done
	return 1
}

is_available_disk() {
	local dev=$1
	local b=$(echo $p | sed 's:/:!:g')

	# check if its a "root" block device and not a partition
	[ -e /sys/block/$b ] || return 1
393

Natanael Copa's avatar
Natanael Copa committed
394 395 396 397
	# check so it does not have mounted partitions
	has_mounted_part $dev && return 1

	# check so its not part of an md setup
398 399 400 401
	if has_holders /sys/block/$b; then
		[ -n "$USE_RAID" ] && echo "Warning: $dev is part of a running raid" >&2
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
402 403 404 405 406 407 408

	# check so its not an md device
	[ -e /sys/block/$b/md ] && return 1

	return 0
}

409
find_disks() {
Natanael Copa's avatar
Natanael Copa committed
410
	local p=
411
	for p in $(awk '$1 ~ /[0-9]+/ {print $4}' /proc/partitions); do
Natanael Copa's avatar
Natanael Copa committed
412
		is_available_disk $p && echo -n " $p"
413 414 415
	done
}

416 417 418 419 420 421 422 423 424 425 426
stop_all_raid() {
	local rd
	for rd in /dev/md*; do
		[ -b $rd ] && mdadm --stop $rd
	done
}

# install needed programs
init_progs() {
	local raidpkg=
	[ -n "$USE_RAID" ] && raidpkg="mdadm"
427 428 429 430 431 432
	case $ROOTFS in
	ext*) fstools=e2fsprogs; mkfs_args="-q";;
	xfs) fstools=xfsprogs; mkfs_args="-q";;
	btrfs) fstools=btrs-progs; mkfs_args="";;
	esac
	apk add --quiet sfdisk e2fsprogs lvm2 $raidpkg syslinux $fstools $@
433 434
}

435
show_disk_info() {
Natanael Copa's avatar
Natanael Copa committed
436
	local disk= vendor= model= d= size=
437
	for disk in $@; do
438 439
		local dev=${disk#/dev/}
		d=$(echo $dev | sed 's:/:!:g')
440 441 442
		vendor=$(cat /sys/block/$d/device/vendor 2>/dev/null)
		model=$(cat /sys/block/$d/device/model 2>/dev/null)
		size=$(awk '{gb = ($1 * 512)/1000000000; printf "%.1f GB\n", gb}' /sys/block/$d/size 2>/dev/null)
443
		echo "  $dev	($size $vendor $model)"
444 445
	done
}
446

447 448
confirm_erase() {
	local answer=
449 450 451 452
	local erasedisks="$@"
	if [ "$ERASE_DISKS" = "$erasedisks" ]; then
		reeturn 0
	fi
453
	echo "WARNING: The following disk(s) will be erased:"
454
	show_disk_info $@
455
	echo -n "WARNING: Erase the above disk(s) and continue? [y/N]: "
456

457 458
	read answer
	case "$answer" in
459
		y*|Y*) return 0;;
460
	esac
461
	return 1
462 463
}

464
# setup partitions on given disk dev in $1.
465
# usage: setup_partitions <diskdev> size1,type1 [size2,type2 ...]
466 467 468 469 470
setup_partitions() {
	local diskdev="$1"
	shift

	echo "Initializing partitions on $diskdev..."
471 472 473 474 475 476 477

	# new disks does not have an DOS signature in sector 0
	# this makes sfdisk complain. We can workaround this by letting
	# fdisk create that DOS signature, by just do a "w", a write.
	# http://bugs.alpinelinux.org/issues/show/145
	echo "w" | fdisk $diskdev >/dev/null

478 479 480
	# fix the MBR while here so extlinux can boot
	cat "$MBR" > $diskdev

481 482
	local start=0
	local line=
483 484
	# create new partitions
	(
485 486 487 488
		for line in "$@"; do
			echo "$start,$line"
			start=
		done
489
	) | sfdisk -q -L -uM $diskdev >/dev/null || return 1
490 491 492 493 494 495 496 497 498 499 500

	# create device nodes if not exist
	mdev -s
}

# find the bootable partition on given disk
find_boot_partition() {
	sfdisk -d $1 | awk '/bootable/ {print $1}'
}

# find the partition(s) for LVM
501
# this is not marked as bootable and is type 8e
502 503 504 505 506
find_lvm_partition() {
	local type=8e
	sfdisk -d $1 | grep -v bootable | awk "/Id=$type/ {print \$1}"
}

507
# set up optional raid and create filesystem on boot device.
508
setup_boot_dev() {
509 510 511 512
	local disk= bootdev=
	local part=$(for disk in $@; do find_boot_partition $disk; done)
	set -- $part
	bootdev=$1
513
	[ -z "$bootdev" ] && return 1
514
	echo "Creating file systems..."
515
	if [ -n "$USE_RAID" ]; then
516 517 518 519 520 521
		local missing=
		local num=$#
		if [ $# -eq 1 ]; then
			missing="missing"
			num=2
		fi
522
		# we only use raid level 1 for boot devices
523 524
		mdadm --create /dev/md0 --level=1 --raid-devices=$num \
			--metadata=0.90 --quiet --run $@ $missing || return 1
525 526
		bootdev=/dev/md0
	fi
527
	mkfs.$BOOTFS -q $bootdev
528 529 530 531
	BOOT_DEV="$bootdev"
}

# $1 = index
532 533 534
# $2 = partition type
# $3... = disk devices
find_nth_non_boot_parts() {
535
	local idx=$1
536
	local id=$2
537 538
	local disk=
	shift
539
	shift
540 541
	for disk in $@; do
		sfdisk -d $disk | grep -v bootable \
542
			| awk "/Id=$id/ { i++; if (i==$idx) print \$1 }"
543 544 545 546 547 548 549 550 551
	done
}

setup_non_boot_raid_dev() {
	local md_dev=$1
	local idx=${md_dev#/dev/md}
	shift
	local level=1
	local missing=
552
	local raid_parts=$(find_nth_non_boot_parts $idx "fd" $@)
553 554 555 556 557 558 559 560 561 562
	set -- $raid_parts
	# how many disks do we have?
	case $# in
		0) echo "No Raid partitions found" >&2; return 1;;
		1) level=1; missing="missing"; num=2;;
		2) level=1; missing=  ; num=2;;
		*) level=5; missing=  ; num=$#;;
	esac
	mdadm --create /dev/md$idx --level=$level --raid-devices=$num \
		--quiet --run $@ $missing || return 1
563 564 565 566
}

# setup device for lvm, create raid array if needed
setup_lvm_volume_group() {
567 568 569
	local vgname="$1"
	shift
	local lvmdev=
570 571

	if [ -n "$USE_RAID" ]; then
572 573
		setup_non_boot_raid_dev /dev/md1 $@ || return 1
		lvmdev=/dev/md1
574
	else
575
		lvmdev=$(find_lvm_partition $1)
576 577 578 579 580
	fi

	# be quiet on success
	local errmsg=$(dd if=/dev/zero of=$lvmdev bs=1k count=1 2>&1) \
		|| echo "$errmsg"
581 582 583 584 585 586 587 588 589 590 591 592
	pvcreate --quiet $lvmdev \
		&& vgcreate --quiet $vgname $lvmdev >/dev/null
}

# set up swap on given device(s)
setup_swap_dev() {
	local swap_dev=
	sed -i -e '/swap/d' /etc/fstab
	for swap_dev in "$@"; do
		mkswap $swap_dev >/dev/null
		echo -e "$swap_dev\tswap\t\tswap\tdefaults 0 0" >> /etc/fstab
	done
593
	SWAP_DEVICE="$(uuid_or_device $swap_dev)"
594 595
	swapon -a
	rc-update --quiet add swap boot
596 597 598
}

# setup and enable swap on given volumegroup if needed
599
setup_lvm_swap() {
600
	local vgname="$1"
601
	local swapname=lv_swap
602 603 604
	if [ -z "$SWAP_SIZE" ] || [ "$SWAP_SIZE" -eq 0 ]; then
		return
	fi
605 606
	lvcreate --quiet -n $swapname -L ${SWAP_SIZE}MB $vgname
	setup_swap_dev /dev/$vgname/$swapname
607 608 609 610 611 612 613 614 615 616
}

# if /var is mounted, move out data and umount it
reset_var() {
	[ -z "$(find_mount_dev /var)" ] && return 0
	mkdir /.var
	mv /var/* /.var/ 2>/dev/null
	umount /var && 	rm -rf /var && mv /.var /var && rm -rf /var/lost+found
}

617 618 619
# set up /var on given device
setup_var() {
	local var_dev="$1"
620
	local varfs=${VARFS}
621
	echo "Creating file systems..."
622
	mkfs.$varfs $var_dev >/dev/null || return 1
623 624 625 626 627 628 629 630 631 632
	sed -i -e '/[[:space:]]\/var[[:space:]]/d' /etc/fstab
	echo -e "${var_dev}\t/var\t\t${varfs}\tdefaults 1 2" >> /etc/fstab

	mv /var /.var
	mkdir /var
	mount /var
	mv /.var/* /var/
	rmdir /.var

	/etc/init.d/syslog --quiet restart
633
	setup_mdadm_conf
634 635
}

636
setup_mdadm_conf() {
637
	local mods= mod=
638 639 640
	if [ -n "$USE_RAID" ]; then
		mdadm --detail --scan > /etc/mdadm.conf
		rc-update --quiet add mdadm-raid boot
641 642 643 644 645 646
		mods=$(awk '/^raid/ {print $1}' /proc/modules)
		for mod in $mods; do
			if ! grep -q "^$mod" /etc/modules; then
				echo $mod >> /etc/modules
			fi
		done
647 648 649
	fi
}

650
data_only_disk_install_lvm() {
651
	local diskdev=
652 653
	local vgname=vg0
	local var_dev=/dev/$vgname/lv_var
654 655 656
	local lvm_part_type="8e"
	local part_type=$lvm_part_type
	local size=
657 658

	init_progs || return 1
659
	confirm_erase $@ || return 1
660

661
	if [ "$USE_RAID" ]; then
662 663
		# the paritition type for raid is "fd"
		part_type="fd"
664 665
		stop_all_raid
	fi
666

667 668 669
	for diskdev in "$@"; do
		setup_partitions $diskdev "$size,$part_type" || return 1
	done
670

671 672
	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
673
	lvcreate --quiet -n ${var_dev##*/} -l 100%FREE $vgname
674
	setup_mdadm_conf
Natanael Copa's avatar
Natanael Copa committed
675
	rc-update add lvm boot
676
	setup_var $var_dev
677 678
}

679 680
data_only_disk_install() {
	local diskdev=
681 682
	local var_dev=
	local var_part_type="83"
683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714
	local swap_part_type=82
	local size=
	local swap_dev= var_dev=

	init_progs || return 1
	confirm_erase $@ || return 1

	if [ "$USE_RAID" ]; then
		var_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi

	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$SWAP_SIZE,$swap_part_type" \
			"$size,$var_part_type" || return 1
	done

	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		var_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		var_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_var $var_dev
}

715
# setup
716 717
setup_root() {
	local root_dev="$1" boot_dev="$2"
718
	mkfs.$ROOTFS $mkfs_args "$root_dev"
719 720
	mkdir -p "$SYSROOT"
	mount -t $ROOTFS $root_dev "$SYSROOT" || return 1
721
	if [ -n "$boot_dev" ]; then
722 723
		mkdir -p "$SYSROOT"/boot
		mount -t $BOOTFS $boot_dev "$SYSROOT"/boot || return 1
724 725 726
	fi

	setup_mdadm_conf
727 728
	install_mounted_root "$SYSROOT" || return 1
	unmount_partitions "$SYSROOT"
729 730 731
	swapoff -a

	echo ""
732
	echo "Installation is complete. Please reboot."
733 734
}

735
native_disk_install_lvm() {
736 737 738 739 740 741 742
	local diskdev= vgname=vg0
	local lvm_part_type="8e"
	local boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local lvm_size=
	local root_dev=/dev/$vgname/lv_root

743
	init_progs || return 1
744
	confirm_erase $@ || return 1
745 746

	if [ -n "$USE_RAID" ]; then
747 748 749
		boot_part_type="fd"
		lvm_part_type="fd"
		stop_all_raid
750
	fi
751 752 753 754 755 756 757 758 759 760 761 762
	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$boot_size,$boot_part_type,*" \
			"$lvm_size,$lvm_part_type" || return 1
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@

	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
	lvcreate --quiet -n ${root_dev##*/} -l 100%FREE $vgname
Natanael Copa's avatar
Natanael Copa committed
763
	rc-update add lvm boot
764
	setup_root $root_dev $BOOT_DEV
Natanael Copa's avatar
Natanael Copa committed
765 766
}

767 768 769 770 771 772 773
native_disk_install() {
	local root_part_type="83" swap_part_type="82" boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local swap_size=${SWAP_SIZE}
	local root_size=
	local root_dev= boot_dev= swap_dev=

774
	init_progs || return 1
775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792
	confirm_erase $@ || return 1

	if [ -n "$USE_RAID" ]; then
		boot_part_type="fd"
		root_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi
	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$boot_size,$boot_part_type,*" \
			"$swap_size,$swap_part_type" \
			"$root_size,$root_part_type" \
			|| return 1
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@
793

794 795 796 797 798 799 800 801 802 803 804 805 806
	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		root_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		root_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_root $root_dev $BOOT_DEV
}

807
diskselect_help() {
808 809
	cat <<__EOF__

Natanael Copa's avatar
Natanael Copa committed
810
The disk you select can be used for a traditional disk install or for a
811 812 813 814
data-only install.

The disk will be erased.

Natanael Copa's avatar
Natanael Copa committed
815
Enter 'none' if you want to run diskless.
816 817 818 819

__EOF__
}

820
diskmode_help() {
821 822
	cat <<__EOF__

823
You can select between 'sys' or 'data'.
824

Natanael Copa's avatar
Natanael Copa committed
825 826 827
sys:
  This mode is a traditional disk install. The following partitions will be
  created on the disk: /boot, / (filesystem root) and swap.
828

Natanael Copa's avatar
Natanael Copa committed
829
  This mode may be used for development boxes, desktops, virtual servers, etc.
830

Natanael Copa's avatar
Natanael Copa committed
831 832 833
data:
  This mode uses your disk(s) for data storage, not for the operating system.
  The system itself will run from tmpfs (RAM).
834

Natanael Copa's avatar
Natanael Copa committed
835 836
  Use this mode if you only want to use the disk(s) for a mailspool, databases,
  logs, etc.
837 838 839 840 841 842 843 844 845

__EOF__
}

# ask for a root or data disk
# returns answer in global variable $answer
ask_disk() {
	local prompt="$1"
	local help_func="$2"
846
	local i=
847 848
	shift 2
	answer=
849
	local default_disk=${DEFAULT_DISK:-$1}
850

851 852 853
	while ! all_in_list "$answer" $@ "none" "abort"; do
		echo "Available disks are:"
		show_disk_info "$@"
854 855
		echon "$prompt [$default_disk] "
		default_read answer $default_disk
856 857 858 859
		case "$answer" in
			'abort') exit 0;;
			'none') return 0;;
			'?') $help_func;;
860 861 862 863 864 865
			*) for i in $answer; do
				if ! [ -b "/dev/$i" ]; then
					echo "/dev/$i is not a block device" >&2
					answer=
				   fi
			done;;
866 867 868 869
		esac
	done
}

870 871
usage() {
	cat <<__EOF__
872
usage: setup-disk [-hLqrv] [-k kernelflavor] [-m MODE] [-o apkovl] [-s SWAPSIZE]
873 874 875 876 877 878 879 880 881 882 883 884 885
		  [MOUNTPOINT | DISKDEV...]

Install alpine on harddisk.

If MOUNTPOINT is specified, then do a traditional disk install with MOUNTPOINT
as root.

If DISKDEV is specified, then use the specified disk(s) without asking. If
multiple disks are specified then set them up in a RAID array. If there are
mode than 2 disks, then use raid level 5 instead of raid level 1.

options:
 -h  Show this help
886
 -m  Use disk for MODE without asking, where MODE is either 'data' or 'sys'
887 888
 -o  Restore system from given apkovl file
 -k  Use kernelflavor instead of $KERNEL_FLAVOR
889
 -L  Use LVM to manage partitions
890 891
 -q  Exit quietly if no disks are found
 -r  Enable software raid1 with single disk
892
 -s  Use SWAPSIZE MB instead of autodetecting swap size (Use 0 to disable swap)
893
 -v  Be more verbose about what is happening
894

895 896 897 898
__EOF__
	exit 1
}

Francesco Colista's avatar
Francesco Colista committed
899 900 901 902 903
kver=$(uname -r)
case $kver in
        *-rc[0-9]*) KERNEL_FLAVOR=vanilla;;
        *-[a-z]*) KERNEL_FLAVOR=${kver##*-};;
        *) KERNEL_FLAVOR=vanilla;;
904 905
esac

906
DISK_MODE=
907
USE_LVM=
908
# Parse args
909
while getopts "hk:Lm:o:qrs:v" opt; do
910
	case $opt in
911
		m) DISK_MODE="$OPTARG";;
912
		k) KERNEL_FLAVOR="$OPTARG";;
913
		L) USE_LVM="_lvm";;
914
		o) APKOVL="$OPTARG";;
915 916
		q) QUIET=1;;
		r) USE_RAID=1;;
917
		s) SWAP_SIZE="$OPTARG";;
918
		v) VERBOSE=1;;
Natanael Copa's avatar
Natanael Copa committed
919
		*) usage;;
920 921
	esac
done
922
shift $(( $OPTIND - 1))
923

924 925
if [ -d "$1" ]; then
	# install to given mounted root
926
	apk add --quiet syslinux
927 928
	install_mounted_root "${1%/}" \
		&& echo "You might need fix the MBR to be able to boot" >&2
929 930 931
	exit $?
fi

932 933 934 935 936 937 938 939 940 941
reset_var
swapoff -a

# stop all volume groups in use
vgchange --ignorelockingfailure -a n >/dev/null 2>&1

if [ -n "$USE_RAID" ]; then
	stop_all_raid
fi

942
disks=$(find_disks)
943
diskdevs=
Natanael Copa's avatar
Natanael Copa committed
944 945

# no disks so lets exit quietly.
946 947 948 949
if [ -z "$disks" ]; then
	[ -z "$QUIET" ] && echo "No disks found." >&2
	exit 0
fi
Natanael Copa's avatar
Natanael Copa committed
950

951
if [ $# -gt 0 ]; then
952
	# check that they are
953 954 955
	for i in "$@"; do
		j=$(readlink -f "$i" | sed 's:^/dev/::; s:/:!:g')
		if ! [ -e "/sys/block/$j/device" ]; then
Natanael Copa's avatar
Natanael Copa committed
956
			echo "$i is not a suitable for partitioning"
957 958
			exit 1
		fi
959
		diskdevs="$diskdevs /dev/${j//!//}"
960 961
	done
else
962
	ask_disk "Which disk(s) would you like to use? (or '?' for help or 'none')" \
963
		diskselect_help $disks
964
	if [ "$answer" != none ]; then
965 966 967
		for i in $answer; do
			diskdevs="$diskdevs /dev/$i"
		done
968 969
	else
		DISK_MODE="none"
970
	fi
971
fi
Natanael Copa's avatar
Natanael Copa committed
972

973
if [ -n "$diskdevs" ] && [ -z "$DISK_MODE" ]; then
974
	answer=
975
	disk_is_or_disks_are="disk is"
976
	it_them="it"
977
	set -- $diskdevs
978
	if [ $# -gt 1 ]; then
979
		disk_is_or_disks_are="disks are"
980 981
		it_them="them"
	fi
982

983
	while true; do
984
		echo "The following $disk_is_or_disks_are selected:"
985
		show_disk_info $diskdevs
986
		echon "How would you like to use $it_them? ('sys', 'data' or '?' for help) [?] "
987 988 989
		default_read answer '?'
		case "$answer" in
		'?') diskmode_help;;
990
		sys|data) break;;
991 992
		esac
	done
993
	DISK_MODE="$answer"
994
fi
Natanael Copa's avatar
Natanael Copa committed
995

996 997 998 999
if [ -z "$SWAP_SIZE" ]; then
	SWAP_SIZE=$(find_swap_size $diskdevs)
fi

1000 1001 1002 1003
set -- $diskdevs
if [ $# -gt 1 ]; then
	USE_RAID=1
fi
1004

1005 1006
dmesg -n1

1007
# native disk install
1008
case "$DISK_MODE" in
1009
sys) native_disk_install$USE_LVM $diskdevs;;
1010
data) data_only_disk_install$USE_LVM $diskdevs;;
1011
none) exit 0;;
1012
*) echo "Not a valid install mode: $DISK_MODE" >&2; exit 1;;
1013
esac
Natanael Copa's avatar
Natanael Copa committed
1014

1015
echo "$DISK_MODE" > /tmp/alpine-install-diskmode.out